function openPopup() {
  if (this.readingContinuously === true) {
    this.readingContinuously = false;
    updateButtonStyles(this);
  }
  this.$.ti_nvm_widget_dialog.open();
}

function closePopup() {
  this.$.ti_nvm_widget_dialog.close();
}

function nvmLoad() {
  if(arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.loadNVM();
}

function verifyNvm() {
  if(arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.verifyNVM();
}

function retryNvm() {
  if(arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.retryNVM();
}

function cancelNvm() {
  if(arguments[0].currentTarget.disabled) {
    return;
  }
  this.$.ti_mdbu_file_nvmprogrammer.cancelNVM();
}

function closeNVM() {
  this.$.ti_mdbu_file_nvmprogrammer.resetTab();
  this.$.ti_nvm_widget_dialog.close();
}

function navToVtabContainer() {
  this.$.ti_basic_tuning_widget_tabcontainer.selectedIndex = 1;
  this.$.ti_mdbu_custom_dropdown_component.selectedValue = this.$.ti_mdbu_custom_card_option_container.selectedOptions[0];
  if (this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 0 || this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 1) {
    this.$.ti_mdbu_custom_dropdown_component.fire('change');
  }
}

function navToUserSelectPage() {
  this.$.ti_basic_tuning_widget_tabcontainer.selectedIndex = 0;
}

function openMemoryViewer() {
  if (this.readingContinuously === true) {
    this.readingContinuously = false;
    updateButtonStyles(this);
  }
  this.$.ti_mdbu_custom_mem_viewer_widget.openMemoryViewer();
}

function writeEEPROM() {
  if (gc.connectionManager.status == "connected") {
    var obj = {
      "addr": 238,
      "size": 32
    };
    CustomCodec.prototype.readValue(obj)
      .then(function (regValue) {
        var regWriteCmd = 0x80000000 | regValue;
        return CustomCodec.prototype.writeValue(obj, regWriteCmd)
          .then(function () {
              templateObj.showToastMsg('success', 'EEPROM write_cmd successful', 4);
            },
            function (err) {
              templateObj.showToastMsg('error', 'EEPROM write_cmd failed', 4);
            });
      }, function (err) {
        templateObj.showToastMsg('error', "EEPROM write failed.", 4);
      });
  }
}

function readEEPROM() {
  if (gc.connectionManager.status == "connected") {
    var obj = {
      "addr": 238,
      "size": 32
    };
    CustomCodec.prototype.readValue(obj)
      .then(function (regValue) {
        var regReadCmdValue = 0x40000000 | regValue;
        return CustomCodec.prototype.writeValue(obj, regReadCmdValue)
          .then(function () {
              this.$.ti_widget_register_page._readAllRegistersClickHdlr();
              templateObj.showToastMsg('success', 'EEPROM read_cmd successful', 4);
            },
            function (err) {
              templateObj.showToastMsg('error', 'EEPROM read_cmd failed', 4);
            });
      }, function (err) {
        templateObj.showToastMsg('error', "Initial Read failed", 4);
      });
  }
}

function navToQuickStart() {
  this.$.ti_mdbu_custom_card_option_item1.selected = true;
  this.$.ti_mdbu_custom_card_option_item1.fire("cardOptionSelected", {
    'id': 'ti_mdbu_custom_card_option_item1',
    'option': this.$.ti_mdbu_custom_card_option_item1.optionName
  });
  this.$.ti_basic_tuning_nav_widget_button.fire('custom_button_click');
  this.$.ti_basic_tuning_custom_widget_vtabcontainer.selectedIndex = 0;
  this.$.ti_basic_tuning_custom_widget_tabcontainer.selectedIndex = 0;
}

function navToBasicTuningPage() {
  this.$.ti_widget_vtabcontainer.selectedIndex = 2;
}

function navToAdvTuningPage() {
  this.$.ti_widget_vtabcontainer.selectedIndex = 3;
}

function openFaultConfigDialog() {
  this.$.ti_widget_dialog.open();
}

function closeFaultConfigDialog() {
  this.$.ti_widget_dialog.close();
}

function moveToPrevTab(event) {
  event.detail.prevButtonClickHdlr();
}

function moveToNextTab(event) {
  var activeTabId = event.detail.id;
  var activeTab = event.srcElement.querySelector("#" + activeTabId);
  var stepListComponent = activeTab.querySelector("ti-mdbu-custom-step-list-component");
  if (stepListComponent) {
    showIncompleteSteps(stepListComponent, event.detail.nextButtonClickHdlr);
  } else {
    event.detail.nextButtonClickHdlr();
  }
}

function displayDraggableAndFloatinfo(event) {
  var helpInfoActiveIndexes = [2, 3, 4];
  if (event.target.localName === 'ti-widget-vtabcontainer') {
    if (helpInfoActiveIndexes.indexOf(event.target.selectedIndex) != -1) {
      this.$.ti_mdbu_custom_floating_info.hidden = false;
      this.$.ti_mdbu_draggable_container.hidden = true;
      this.$.ti_right_panel_widget_container18.hidden = false;
      // Change the navigation toggle button values with respect to selected index
      if (this.$.ti_widget_vtabcontainer.selectedIndex === 2) {
        this.$.ti_adv_tuning_nav_custom_widget_toggle_button5.checked = false;
        this.$.ti_basic_tuning_nav_custom_widget_toggle_button1.checked = false;
      }
      if (this.$.ti_widget_vtabcontainer.selectedIndex === 3) {
        this.$.ti_basic_tuning_nav_custom_widget_toggle_button1.checked = true;
        this.$.ti_adv_tuning_nav_custom_widget_toggle_button5.checked = true;
      }
    } else {
      this.$.ti_mdbu_custom_floating_info.hidden = true;
      this.$.ti_mdbu_draggable_container.hidden = true;
      this.$.ti_right_panel_widget_container18.hidden = true;
    }
  }
}

function selectedVtabChanged(event) {
  displayDraggableAndFloatinfo.call(this, event);

  if (event.target.selectedIndex === 6) {
    console.log("Serial port selected");
    document.querySelector("ti-service-serialio").openDialog()
    this.$.ti_widget_vtabcontainer.selectedIndex = this.prevSelectedIndex;
  } else {
    this.prevSelectedIndex = event.target.selectedIndex;
  }
}

function toggleMenu(event) {
  this.$.ti_widget_vtabcontainer.isExpanded = !this.$.ti_widget_vtabcontainer.isExpanded;
}

function readAllRegisters(event) {
  this.$.ti_widget_register_page._readAllRegistersClickHdlr();
}

function updateDroplistLabels(regBindings, droplistLabels) {
  var iterable = regBindings.srcBindRegField.widget ? regBindings.srcBindRegField.widget.options : regBindings.srcBindRegField.options;
  for (var i in iterable) {
    iterable[i].display = droplistLabels[i];
  }
  this.refreshRegmap();
  for (var controlName of regBindings.destBindControls) {
    var controlElem = document.querySelector('#' + controlName);
    if (controlElem.localName === 'ti-mdbu-custom-dropdown-component') {
      controlElem.droplistLabels = droplistLabels.join('|');
    }
  }
}

function handleCSAModeChange(event) {
  var droplistLabels = event.currentTarget.checked ? ['Pin sense', '0.1 V', '0.2 V', '0.3 V', '0.4 V', '5 V', '0.6 V', '0.7 V', '0.8 V', '0.9 V', '1 V', '1.1 V', '1.2 V', '1.3 V', '1.4 V', '1.5 V'] : ['Pin sense', '0.2 V', '0.4 V', '0.6 V', '0.8 V', '1 V', '1.2 V', '1.4 V', '1.6 V', '1.8 V', '2 V', '2.2 V', '2.4 V', '2.6 V', '2.8 V', '3 V'];
  var regBindings = this.getHighlevelBindedControls('my_model', 'MOTOR_STARTUP1', 'IPD_CURR_THR');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
  regBindings = this.getHighlevelBindedControls('my_model', 'MOTOR_STARTUP2', 'OL_ILIMIT');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
  regBindings = this.getHighlevelBindedControls('my_model', 'FAULT_CONFIG1', 'ILIMIT');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
  regBindings = this.getHighlevelBindedControls('my_model', 'FAULT_CONFIG1', 'LOCK_ILIMIT');
  updateDroplistLabels.bind(this, regBindings, droplistLabels)();
}

function showInitSettingsPopup(event) {
  if (this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 0 || this.$.ti_mdbu_custom_dropdown_component.selectedIndex === 1) {
    this.$.ti_beginner_init_settings_dialog.open();
  }
}

function closeInitSettingsPopup(event) {
  this.$.ti_beginner_init_settings_dialog.close();
}

function enableBeginnerInitSettings(event) {
  gc.fileCache.readJsonFile('regInitSettings.json').then((content) => {
    try {
      if (content) {
        templateObj.setRegisterData(content);
        templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded default registers.");
      }
    } catch (ex) {
      templateObj.logMsgAndNotify("error", "Load Registers: Could not parse file:" + ex, false, true);
    }
  })
  this.$.ti_beginner_init_settings_dialog.close();
}

function updateButtonStyles(self) {
  if (self.readingContinuously) {
    self.$.ti_widget_basic_read_registers.disabled = true;
    self.$.ti_widget_adv_read_registers.disabled = true;
    self.$.ti_widget_eval_read_registers.disabled = true;
    self.$.ti_widget_basic_read_cont.classList.add("custom-button-pressed");
    self.$.ti_widget_adv_read_cont.classList.add("custom-button-pressed");
    self.$.ti_widget_eval_read_cont.classList.add("custom-button-pressed");
    self.$.ti_widget_write_eeprom_button.disabled = true;
    self.$.ti_widget_read_eeprom_button.disabled = true;
    self.$.ti_widget_register_page.$.read_register.disabled = true;
    self.$.ti_widget_register_page.$.read_all_registers.disabled = true;
  } else {
    self.$.ti_widget_basic_read_registers.disabled = false;
    self.$.ti_widget_adv_read_registers.disabled = false;
    self.$.ti_widget_eval_read_registers.disabled = false;
    self.$.ti_widget_basic_read_cont.classList.remove("custom-button-pressed");
    self.$.ti_widget_adv_read_cont.classList.remove("custom-button-pressed");
    self.$.ti_widget_eval_read_cont.classList.remove("custom-button-pressed");
    self.$.ti_widget_write_eeprom_button.disabled = false;
    self.$.ti_widget_read_eeprom_button.disabled = false;
    self.$.ti_widget_register_page.$.read_register.disabled = false;
    self.$.ti_widget_register_page.$.read_all_registers.disabled = false;
  }
}

function disableAutoReadButtons (self) {
  self.$.ti_widget_basic_read_cont.disabled = true;
  self.$.ti_widget_adv_read_cont.disabled = true;
  self.$.ti_widget_eval_read_cont.disabled = true;
}

function enableAutoReadButtons(self) {
  self.$.ti_widget_basic_read_cont.disabled = false;
  self.$.ti_widget_adv_read_cont.disabled = false;
  self.$.ti_widget_eval_read_cont.disabled = false;
}

function readAllRegistersFromButton(event) {
  if (this.$.ti_widget_basic_read_registers.disabled) {
    return;
  }
  readAllRegisters.call(this, event);
}

function readRegistersContinuously(event, eventCall) {
  var self = this;
  if (self.$.ti_widget_basic_read_cont.disabled) {
    return;
  }
  if (eventCall !== false) {
    this.readingContinuously = !this.readingContinuously;
  }
  if(this.readingContinuously === false && this.readingInProgress === true) {
    disableAutoReadButtons(self);
  }
  if (this.readingContinuously === true) {
    updateButtonStyles(self);
    if (gc.connectionManager.status != "connected") {
      return;
    } else {
      readAllRegisters.call(self, event);
      self.readingInProgress = true;
      self.$.ti_widget_register_page.addEventListener("read_regs", function continuousRead(e) {
        var detailObj = e.detail;
        if (detailObj.statusType === "info") {
          self.$.ti_widget_register_page.removeEventListener("read_regs", continuousRead);
          if (self.readingContinuously === true) {
            readRegistersContinuously.call(self, event, false);
          }
          self.readingInProgress = false;
          enableAutoReadButtons(self);
        } else {
          self.$.ti_widget_register_page.removeEventListener("read_regs", continuousRead);
          self.readingContinuously = false;
          updateButtonStyles(self);
          self.readingInProgress = false;
          enableAutoReadButtons(self);
        }
      });
    }
  } else {
    updateButtonStyles(self);
  }
}

function updateButtonsBasedOnGraphState() {
  if (this.readingContinuously) {
    this.readingContinuously = false;
  }
  updateButtonStyles(this);
}